#
#    Project: The EDNA Kernel
#             http://www.edna-site.org
#
#    File: "$Id: EDPluginExec.py 664 2009-05-06 13:05:34Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDPlugin    import EDPlugin

from EDImportLib import EDVerbose

class EDPluginExec( EDPlugin ):
    """
    Super class for all plugins that execute something.
    For now, does nothing else than calling parent methods for now. Unecessary methods should be cleaned up
    """
    
    def __init__ ( self ):
        """
        """
        EDPlugin.__init__( self )
        
        
    def preProcess( self, _edObject = None ):
        """
        """
        EDPlugin.preProcess( self )
        EDVerbose.DEBUG( "*** EDPluginExec.preProcess")
        
        
    def process( self, _edObject = None ):
        """
        """
        EDPlugin.process( self )
        EDVerbose.DEBUG( "*** EDPluginExec.process")
        

    def postProcess( self, _edObject = None ):
        """
        """
        EDPlugin.postProcess( self )
        EDVerbose.DEBUG( "*** EDPluginExec.postProcess")
    

    def configure( self ):
        """
        """
        EDPlugin.configure( self )
        EDVerbose.DEBUG( "*** EDPluginExec.configure")
