#
#    Project: The EDNA Kernel
#             http://www.edna-site.org
#
#    File: "$Id: EDUtilsTable.py 664 2009-05-06 13:05:34Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib                         import EDObject
from EDImportLib                         import EDString
from EDImportLib                         import EDList


class EDUtilsTable (EDObject):
    """
    This class allows to handle an XSDataTable objects (composed with lists that contain items)
    """
    
    def getTableListFromTables( _xsTables, _edTableName ):
        """
        """
        edListOfTables = EDList()
        xsMatchTable = None
        xsTables = _xsTables.getTable()
        for xsTable in xsTables:
            edStringTableName = EDString( xsTable.getName() )
            if ( edStringTableName.equals( _edTableName ) ):
                edListOfTables.append( xsTable )
                
        return edListOfTables
    getTableListFromTables = staticmethod( getTableListFromTables )
        
    
    def getTableFromTables( _xsTables, _edTableName ):
        """
        Returns the last table of name "_edTableName"
        """
        xsMatchTable = None
        xsTables = _xsTables.getTable()
        for xsTable in xsTables:
            edStringTableName = EDString( xsTable.getName() )
            if ( edStringTableName.equals( _edTableName ) ):
                xsMatchTable = xsTable
                
        return xsMatchTable
    getTableFromTables = staticmethod( getTableFromTables )
    
    
    def getListsFromTable( _xsTable, _edStringListName ):
        """
        """
        xsMatchLists = []
        xsLists = _xsTable.getList()
        for xsList in xsLists:
            edStringListName = EDString( xsList.getName() )
            if ( edStringListName.equals( _edStringListName ) ):
                xsMatchLists.append( xsList )
                
        return xsMatchLists
    getListsFromTable = staticmethod( getListsFromTable )
    
    
    def getItemFromList( _xsList, _edStringItemName ):
        """
        """
        xsMatchItem = None
        xsItems = _xsList.getItem()
        for xsItem in xsItems:
            edStringItemName = EDString( xsItem.getName() )
            if ( edStringItemName.equals( _edStringItemName ) ):
                xsMatchItem = xsItem
                
        return xsMatchItem
    getItemFromList = staticmethod( getItemFromList ) 
        
    
   