#
#    Project: The EDNA Kernel
#             http://www.edna-site.org
#
#    File: "$Id: EDTestSuiteKernel.py 664 2009-05-06 13:05:34Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors: Marie-Francoise Incardona (incardon@esrf.fr)
#                       Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib                          import EDCompiler

from EDTestSuite                          import EDTestSuite


class EDTestSuiteKernel( EDTestSuite ):


    def process( self ):
        self.addTestCaseFromName( "EDTestCaseEDConfiguration" )
        self.addTestCaseFromName( "EDTestCaseEDPluginExecProcessScript" )
        self.addTestCaseFromName( "EDTestCaseEDUtilsImage" )
        self.addTestCaseFromName( "EDTestCaseEDUtilsTable" )
        self.addTestCaseFromName( "EDTestCaseEDUtilsSymmetry" )
        self.addTestCaseFromName( "EDTestCaseEDFactoryPlugin" )


##############################################################################
if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()

    edTestSuiteKernel = EDTestSuiteKernel( "EDTestSuiteKernel" )
    edTestSuiteKernel.execute()

##############################################################################
