#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################



from ALVerbose             import ALVerbose
from ALActionController    import ALActionController


class ALActionMethod( ALActionController ):
    """
    Interface for ALActionMethod classes.

    The methods to be modified by the user (overload):
        def preProcess( self, _oalObject = None )
        def postProcess( self, _oalObject = None

    """

    def __init__( self, _oalClassMethod = None ):
        ALActionController.__init__( self )
        self.m_oalClassMethod = _oalClassMethod



    def executeMethod( self, _oalObject = None ):
        """
        This method starts the thread.
        """
        self.executeAction( _oalObject )



    def process( self, _oalObject = None ):
        """
        This is the main method of the action.
        """
        ALVerbose.aalibDEBUGID( self.getID(), "Execution: ALActionMethod.process()" )
        if ( self.m_oalClassMethod!=None ):
            if ( _oalObject!=None ):
                self.m_oalClassMethod( _oalObject )
            else:
                self.m_oalClassMethod()




    def setMethod( self, _oalClassMethod ):
        """
        """
        ALVerbose.aalibDEBUGID( self.getID(), "Execution: ALActionMethod.getMethod()" )
        self.synchronizeOn()
        self.m_oalClassMethod = _oalClassMethod
        self.synchronizeOff()


    def getMethod( self ):
        """
        """
        ALVerbose.aalibDEBUGID( self.getID(), "Execution: ALActionMethod.getMethod()" )
        return self.m_oalClassMethod



##############################################################################
