#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALDefinition        import  *
from ALTime              import  ALTime
from ALActionSet         import  ALActionSet


class ALActionSetSynchronous( ALActionSet ):
    """
    NOTE: this class is Synchronous

    The methods to be modified by the user (overload):
        def preProcess( self, _oalObject = None )
        def postProcess( self, _oalObject = None )

    """
    def __init__( self ):
        """
        Constructor for ALActionSetSynchronous.
        """
        ALActionSet.__init__( self )




    def __controlTimeOutAction( self, _oalAction, _oalTimeIteration = AL_TIME_MINIMUM * 2 ):
        oalTime = ALTime()
        obStatus = True
        while (obStatus==True):
            self.threadControlTimer( _oalTimeIteration )
            if ( oalTime.getDuration()>_oalAction.getTimeOut() ):
                obStatus = False
                _oalAction.stop()
            if ( _oalAction.isRunning()!=True ):
                obStatus = False
        self.actionControl()
        if ( _oalAction.isRunning()==True ):
            _oalAction.stop()




    def process( self, _oalObject = None ):
        """
        This is the main method of the action.
        """
        for iAction in self.m_oalListAction :
            self.actionControl()

            self.synchronizeOn()
            iAction.connectSUCCESS( self.controlActionSuccess )
            iAction.connectFAILURE( self.controlActionFailure )
            iAction.execute( _oalObject )
            self.synchronizeOff()

            self.actionControl()

            self.synchronizeOn()
            self.__controlTimeOutAction( iAction )
            self.synchronizeOff()



