#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALString  import ALString
from ALToken   import ALToken
from ALList    import ALList


class ALArgument( ALList  ):
    """
    Interface for command line argument objects.
    """
    def __init__( self, _oListArgument = None  ):
        ALList.__init__( self, _oListArgument )


    def existArgument( self, _oalString ):
        oalString = ALString( _oalString )
        if (oalString in self):
            return True
        else:
            return False


    # To be fast
    def getArgument( self, _oalToken ):
        oalToken = ALToken( _oalToken )
        for i in range( 0, len( self )):
            oalTokenList = ALToken( self[i] )
            if (oalTokenList==oalToken):
                j = i+1
                if j < len( self ):
                    return ALString( self[j] )
        return None


    def getArgumentNumber( self, _i = 0 ):
        if (_i <= len( self ) and _i >= 0):
            return  self[ _i ]
        else:
            return None


##############################################################################
