#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALObject  import  ALObject
from ALString  import  ALString
from ALXmlNode import  ALXmlNode


class ALDict( ALObject, dict ):
    """
    Interface for AL dict objects.
    Warning: This class is NOT ordered! The elements sorting is random
    to use a ORDERED dictionary : ALDictionary
    This class will be deprecated in the future
    """
    def __init__( self ):
        ALObject.__init__( self )
        dict.__init__( self )


    def getValue( self, _key ):
        return self.get( _key )


    def setValue( self, _key, _value ):
        self[_key] = _value


    def add( self, _key, _value ):
        self[_key] = _value


    # Basic interface to generic objects
    def getObject( self, _key ):
        return self.get( _key )


    def addObject( self, _key, _value ):
        self[_key] = _value


    def getNumberObjects( self ):
        return len( self )


    def inputXml( self, _oalXmlElement, _oalXml = None  ):
        self.inputXmlObject( _oalXmlElement )

        for inode in _oalXmlElement.childNodes:
            if ( inode.nodeType==ALXmlNode.ELEMENT_NODE ):
                for jnode in inode.childNodes:
                    if ( jnode.nodeType==ALXmlNode.TEXT_NODE ):
                        oalToken  = ALString( inode.nodeName )
                        oalString = ALString( jnode.data )
                        if ( oalToken!="objectID" and oalToken!="objectVersion" and oalToken!="objectName" ):
                            self.addObject( oalToken.cleanXml(), oalString.cleanXml() )


    def outputXml( self, _oalXml, _oalXmlElement ):
        oalXmlElementObject = self.outputXmlObject( _oalXml, _oalXmlElement )

        for ikey in self:
            if ( self[ ikey ] is not None ):
               oalXmlElement = _oalXml.createElement( ALString( ikey ) )
               oalXmlElement.appendChild( _oalXml.createTextNode( ALString( self[ ikey ] ) ) )
               oalXmlElementObject.appendChild( oalXmlElement )

