#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALDefinition    import *
from ALString        import ALString
from ALObject        import ALObject
from ALTime          import ALTime


class ALInformation( ALObject ):
    """
    Interface for Information Classes.
    """
    def __init__( self, _oAuthor = "PLEASE sign your Plugin-Action-Code-Test", _oVersion = AL_VERSION,
                 _oInfo = "Developed with the PyAALib-JyAALib Framework :: 2005-2008",
                 _oContact = "http://jyaalib.sourceforge.net",
                 _oCopyright = "PyAALib-JyAALib Framework is a Free Software" ):
        ALObject.__init__( self )
        self.m_oalAuthor      = ALString( _oAuthor )
        self.m_oalVersion     = ALString( _oVersion )
        self.m_oalInformation = ALString( _oInfo )
        self.m_oalContact     = ALString( _oContact )
        self.m_oalCopyright   = ALString( _oCopyright )
        self.m_oalFileName    = ALString( self.getClassName() )
        self.m_oalGroupName   = ALString( self.getClassName() )
        self.m_oalTimeInit    = 0.0
        self.m_oalTimeEnd     = 0.0
        self.setTimeInit()


    def setTimeInit( self ):
        self.synchronizeOn()
        self.m_oalTimeInit = ALTime.time()
        self.m_oalTimeEnd  = self.m_oalTimeInit
        self.synchronizeOff()


    def setTimeEnd( self ):
        self.synchronizeOn()
        self.m_oalTimeEnd  = ALTime.time()
        self.synchronizeOff()


    def getRunTime( self ):
        self.synchronizeOn()
        oTime = self.m_oalTimeEnd - self.m_oalTimeInit
        self.synchronizeOff()
        return oTime


    def setAuthor( self, _oAuthor ):
        self.synchronizeOn()
        self.m_oalAuthor      = ALString( _oAuthor )
        self.synchronizeOff()

    def setVersion( self, _oVersion ):
        self.synchronizeOn()
        self.m_oalVersion      = ALString( _oVersion )
        self.synchronizeOff()

    def setInformation( self, _oInfo ):
        self.synchronizeOn()
        self.m_oalInformation = ALString( _oInfo )
        self.synchronizeOff()

    def setContact( self, _oContact ):
        self.synchronizeOn()
        self.m_oalContact     = ALString( _oContact )
        self.synchronizeOff()

    def setCopyright( self, _oCopyright ):
        self.synchronizeOn()
        self.m_oalCopyright   = ALString( _oCopyright )
        self.synchronizeOff()

    def setFileName( self, _oFileName ):
        self.synchronizeOn()
        self.m_oalFileName   = ALString( _oFileName )
        self.synchronizeOff()

    def setGroupName( self, _oGroupName ):
        self.synchronizeOn()
        self.m_oalGroupName   = ALString( _oGroupName )
        self.synchronizeOff()


    def getAuthor( self ):
        return self.m_oalAuthor

    def getVersion( self ):
        return self.m_oalVersion

    def getInformation( self ):
        return self.m_oalInformation

    def getContact( self ):
        return self.m_oalContact

    def getCopyright( self ):
        return self.m_oalCopyright

    def getFileName( self ):
        return self.m_oalFileName

    def getGroupName( self ):
        return self.m_oalGroupName


##############################################################################
