#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportPython      import PyXmlRpcServer
from ALImportPython      import PySimpleXMLRPCServer
from ALImportPython      import PySerializer
from ALImportPython      import PyXmlRpcLib
from ALServer      import ALServer
from ALString      import ALString


class ALServerXmlRpc( ALServer ):
    """
    Parent class for all AL XML-RPC Server objects.
    """


    def __init__( self, _oalHostName = "localhost", _oalPortNumber = 8000 ):
        ALServer.__init__( self )
        self.m_oalServerXmlRpc = PySimpleXMLRPCServer( ( _oalHostName, _oalPortNumber ) )
#        self.m_oalServerXmlRpc.register_introspection_functions()


    def executeServer( self ):
        self.m_oalServerXmlRpc.serve_forever()


    def addMethod( self, _oalMethod ):
#        self.m_oalServerXmlRpc.register_introspection_functions()
        self.m_oalServerXmlRpc.register_function( _oalMethod )


    def addObject( self, _oalObject ):
#        self.m_oalServerXmlRpc.register_introspection_functions()
        self.m_oalServerXmlRpc.register_instance( _oalObject )



    def connectServer( _oalStringHostAndSocket = "http://localhost:8000" ):
        return PyXmlRpcServer( _oalStringHostAndSocket )
    connectServer = staticmethod( connectServer )


    def encoder( _oalObject ):
        return PySerializer.dumps( _oalObject )
    encoder = staticmethod( encoder )


    def decoder( _oalStringIO ):
        return PySerializer.loads( _oalStringIO )
    decoder = staticmethod( decoder )


    def response( _oalString = None ):
        if ( _oalString==None ):
            return PyXmlRpcLib.True
        else:
            return ALString( _oalString )
    response = staticmethod( response )



#
#
#1. Install functions:
#
#server = SimpleXMLRPCServer(("localhost", 8000))
#server.register_function(pow)
#server.register_function(lambda x,y: x+y, 'add')
#server.serve_forever()
#
#2. Install an instance:
#
#class MyFuncs:
#    def __init__(self):
#        # make all of the string functions available through
#        # string.func_name
#        import string
#        self.string = string
#    def _listMethods(self):
#        # implement this method so that system.listMethods
#        # knows to advertise the strings methods
#        return list_public_methods(self) + \
#                ['string.' + method for method in list_public_methods(self.string)]
#    def pow(self, x, y): return pow(x, y)
#    def add(self, x, y) : return x + y
#
#server = SimpleXMLRPCServer(("localhost", 8000))
#server.register_introspection_functions()
#server.register_instance(MyFuncs())
#server.serve_forever()
#
#3. Install an instance with custom dispatch method:
#
#class Math:
#    def _listMethods(self):
#        # this method must be present for system.listMethods
#        # to work
#        return ['add', 'pow']
#    def _methodHelp(self, method):
#        # this method must be present for system.methodHelp
#        # to work
#        if method == 'add':
#            return "add(2,3) => 5"
#        elif method == 'pow':
#            return "pow(x, y[, z]) => number"
#        else:
#            # By convention, return empty
#            # string if no help is available
#            return ""
#    def _dispatch(self, method, params):
#        if method == 'pow':
#            return pow(*params)
#        elif method == 'add':
#            return params[0] + params[1]
#        else:
#            raise 'bad method'
#
#server = SimpleXMLRPCServer(("localhost", 8000))
#server.register_introspection_functions()
#server.register_instance(Math())
#server.serve_forever()

##############################################################################
