#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALVerbose         import  ALVerbose
from ALString          import  ALString
from ALDebug           import  ALDebug
from ALTest            import  ALTest
from ALManagerTest     import  ALManagerTest
from ALInformationTest import  ALInformationTest



class ALTestCase( ALTest ):
    """
    Interface for ALTestCase objects.

    # To be modified by the user with its methods
    def process( self ):
    def preProcess( self ):
    def postProcess( self ):

    """

    def __init__( self, _oalStringTestName = None ):
        ALTest.__init__( self, _oalStringTestName )


    def processKernel( self ):

        ointNumberMethods = self.m_oalListTest.getNumberObjects( )
        ALVerbose.unitTest( "===================================================================" )
        ALVerbose.unitTest( "TestCase Total Number of Tests = [ " + ALString( ointNumberMethods ) + " ]" )
        ALVerbose.unitTest( " " )
        ointNumber = 0
        for oTestMethod in self.m_oalListTest:
            ointNumber += 1
            oalInformationTest = ALInformationTest( self.patchMethodName( oTestMethod ), ointNumber )
            ALManagerTest.addInformationTestMethod( oalInformationTest )

            ALVerbose.unitTest( "===================================================================" )
            ALVerbose.unitTest( "TestCase Method [ " + oalInformationTest.getTestName()  + " ]" )
            ALVerbose.unitTest( "TestCase Method [ " + ALString( oalInformationTest.getTestNumber() )  + " ]" )
            ALVerbose.unitTest( "-------------------------------------------------------------------" )


            try:
                oTestMethod()
                oalInformationTest.setTerminate()
                ALVerbose.unitTest( "[ " + oalInformationTest.getTestName() + " ] : [SUCCESS]" )
                ALVerbose.unitTest( " " )
            except AssertionError, opyException:
                oalInformationTest.setTerminate()
                oalInformationTest.setFailure()
                oalInformationTest.setException( ALString(opyException) )
                ALVerbose.unitTest( "TestCase = Assertion Error Raised"  )
                ALVerbose.unitTest( "[ " + oalInformationTest.getTestName() + " ] : [FAILURE]" )
                ALVerbose.unitTest( " " )
                self.raiseControl()

            except Exception, opyException:
                oalInformationTest.setTerminate()
                oalInformationTest.setFailure()
                oalInformationTest.setException( ALString(opyException) )
                ALVerbose.unitTest( "TestCase = Unexpected Error Raised"  )
                ALVerbose.unitTest( "[ " + oalInformationTest.getTestName() + " ] : [FAILURE]" )
                ALVerbose.unitTest( " " )
                self.raiseControl()


##############################################################################