#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *


##############################################################################
# ALContainer

class ALTestCaseALContainer( ALTestCase ):

    def testALContainer(self):
        ALVerbose.unitTest( "UnitTest ALContainer" )
        oalContainer = ALContainer()
        oalContainer.addObject( "oalToken01", "string test token 01" )
        oalContainer.addObject( "oalToken02", "string test token 02" )

        for iToken in oalContainer.getSequence():
            ALVerbose.screen( "Token: " + iToken + " -> value: " + oalContainer.getObject( iToken ) )

        del oalContainer

        ALVerbose.unitTest( )



##############################################################################

    def process( self ):
        self.addTestMethod( self.testALContainer )



##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALContainer = ALTestCaseALContainer( "TestCase ALContainer" )
    oalTestCaseALContainer.execute()
