#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALList( ALTestCase ):
    """
    TestSuite for ALTestCaseALList
    """
    def testALList( self ):
        ALVerbose.unitTest( "Test ALList" )

        oalList = ALList()


        if (oalList.m_opySemaphore!=None):
            ALVerbose.unitTest( "[ok] Semphore is NOT None" )


        oalList.deleteSemaphore()
        if (oalList.m_opySemaphore==None):
            ALVerbose.unitTest( "[ok] Semphore is Delete = None")



        oalList.createSemaphore()
        if (oalList.m_opySemaphore!=None):
            ALVerbose.unitTest( "[ok] Semphore is Created")



        oalListCopy = ALList( oalList )

#        ALAssert.equal( oalList.getID(), oalListCopy.getID() )
        ALAssert.equal( oalList.getMagicNumber(), oalListCopy.getMagicNumber() )

        if (oalListCopy.m_opySemaphore!=None):
            ALVerbose.unitTest( "[ok] Copy Semphore is NOT None")

        oalListCopy.deleteSemaphore()
        if (oalListCopy.m_opySemaphore==None):
            ALVerbose.unitTest( "[ok] Copy Semphore is Delete = None")

        oalListCopy.createSemaphore()
        if (oalListCopy.m_opySemaphore!=None):
            ALVerbose.unitTest( "[ok] Copy Semphore is Created")

        del oalListCopy
        del oalList

        ALVerbose.unitTest( "Deleting Objects" )
        ALVerbose.unitTest( )


    def testALListArgument( self ):
        ALVerbose.unitTest( "UnitTest ALListArgument:" )


        oalList1 = ALList()
        oalList1.append( "--coucou1" )
        oalList1.append( "valeu_coucou1" )
        oalList1.append( "-h1" )
        oalList1.append( "--man1" )
        ALVerbose.unitTest( oalList1 )

        oalList2 = ["--coucou2", "valeu_coucou2", "-h2", "--man2"]
        ALVerbose.unitTest( oalList2 )

        oalList3 = ALList( ["--coucou3", "valeu_coucou3", "-h3", "--man3"] )
        ALVerbose.unitTest( oalList3 )

        oalList4 = ALList( oalList2 )
        ALVerbose.unitTest( oalList4 )


        #oalListArgument = ALListArgument( oalList3 )
        oalListArgument = ALCommandLineArgument()
        ALVerbose.unitTest( oalListArgument )

        ALVerbose.unitTest()


##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALList )
        self.addTestMethod( self.testALListArgument )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALList = ALTestCaseALList( "TestCase ALList" )
    oalTestCaseALList.execute()
