#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALManagerTest( ALTestCase ):
    """
    TestSuite for ALManagerTest
    """
    def testALManagerTest( self ):
        ALVerbose.unitTest( "Test ALManagerTest" )

        oalManagerTest = ALManagerTest()
        del oalManagerTest

        oalInformationTest = ALInformationTest( "TestDemoFather" )
        oalInformationTestSun = ALInformationTest( "MethodTestDemoSun1" )
        oalInformationTestSun.setTerminate()
        oalInformationTest.addInformationTest( oalInformationTestSun )

        oalInformationTestSun = ALInformationTest( "MethodTestDemoSun2" )
        oalInformationTestSun.setTerminate()
        oalInformationTest.addInformationTest( oalInformationTestSun )

        oalInformationTestSun = ALInformationTest( "MethodTestDemoSun3" )
        oalInformationTestSun.setTerminate()
        oalInformationTestSun.setFailure()
        oalInformationTest.addInformationTest( oalInformationTestSun )

        oalInformationTest.setTerminate()

        ALManagerTest.addInformationTest( oalInformationTest )


        ALVerbose.unitTest( "  Total Number of Test Roots: " + ALString( ALManagerTest.getNumberTest()) )
        ALVerbose.unitTest( "Total Number of Test Methods: " + ALString( ALManagerTest.getNumberTestMethod()) )
        ALVerbose.unitTest( "Total Number of Test Success: " + ALString( ALManagerTest.getNumberTestSuccess()) )
        ALVerbose.unitTest( "Total Number of Test Failure: " + ALString( ALManagerTest.getNumberTestFailure()) )

        ALVerbose.unitTest( )



##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALManagerTest )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALManagerTest = ALTestCaseALManagerTest( "TestCase ALManagerTest" )
    oalTestCaseALManagerTest.execute()
