#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALObject( ALTestCase ):
    """
    TestSuite for ALObject Class
    """

    def testALMetaObject( self ):
        print "\nUnitTest ALMetaObject:\n"
        oalMetaObject = ALMetaObject()
        print oalMetaObject
        print "\nEnd UnitTest ALMetaObject \n\n"


    def testALObject( self ):
        print "\nUnitTest ALObject:\n"


        oalObject0 = ALObject()
        #print oalObject0.getMagicNumber()
        ALAssert.equal( "magALObject", oalObject0.getMagicNumber())

        del oalObject0
#        if(oalObject0!=None):
#            ALAssert.equal( "magALObject", oalObject0.getMagicNumber())


        oalObject0 = ALObject()

        # Can't do explicit assert check since ID is a random number.
        print oalObject0.getID()

        #print oalObject0.getVersion()
        ALAssert.equal( "2.0", oalObject0.getVersion() )
        #print oalObject0.getName()
        ALAssert.equal( "objALObject", oalObject0.getName() )




#        oalObject1 = oalObject0.duplicate()
#        ALAssert.equal( oalObject0.getID(), oalObject1.getID() )
##        ALAssert.equal( oalObject0.getMagicNumber(), oalObject1.getMagicNumber() )

#        if oalObject1.getID()==oalObject0.getID():
#            print "Two Objects have the same ID: " + oalObject1.getID()
#            print "Copy object: " + oalObject1.getMagicNumber()
#        else :
#            print "error = Two Objects have different IDs "


        oalXmlObject = ALXml( "alobject-test-xml")
        oalXmlObject.addComment( "Test of ALObject Output in XML " )
        oalXmlObject.addObject( oalObject0 )
        oalXmlObject.output( "alobject-test.xml", True )
        oalXmlObject.destroy()

        oalXmlRead = ALXml()
        oalXmlRead.input( "alobject-test.xml" )
        oalXmlRead.output( "alobject-test-COPY.xml" )
        oalXmlRead.close()

        oalXsd = ALStreamFile( "teste.xsd" )
        oalXsd.write("<?xml version=\"1.0\"?>\n")
        oalXsd.write("<xs:schema xmlns:xs=\"http://www.w3.org/2001/XMLSchema\">\n")
        oalObject0.outputXsd( oalXsd )
        oalXsd.write("</xs:schema>\n")
        oalXsd.close()

        import sys
        oalObject0.outputXsd()
        oalPlugin = ALPlugin()
        oalPlugin.outputXsd()

        oalPlugin.outputClassMembers()

#        Tests
#        import pyclbr
#        pyclbr.readmodule( ALObject.py, "../modules" )

        print "\n  [UnitTest] End UnitTest ALObject \n\n"




    def testALObjectDuplicate( self ):
        print "\n  [UnitTest] UnitTest ALObjectDuplicate:\n"


        oalObject0 = ALObject()
        #print oalObject0.getMagicNumber()
        ALAssert.equal( "magALObject", oalObject0.getMagicNumber())

        del oalObject0


        oalObject0 = ALObject()
        if(oalObject0!=None):
            ALAssert.equal( "magALObject", oalObject0.getMagicNumber())


        oalObject0 = ALObject()

        # Can't do explicit assert check since ID is a random number.
        print "  " + oalObject0.getID()

        #print oalObject0.getVersion()
        ALAssert.equal( "2.0", oalObject0.getVersion() )
        #print oalObject0.getName()
        ALAssert.equal( "objALObject", oalObject0.getName() )


        if (oalObject0.m_opySemaphore!=None):
            print "  [ok] Semphore is NOT None"


        oalObject0.deleteSemaphore()
        if (oalObject0.m_opySemaphore==None):
            print "  [ok] Semphore is Delete = None"



        oalObject0.createSemaphore()
        if (oalObject0.m_opySemaphore!=None):
            print "  [ok] Semphore is Created"




        print "\n  [UnitTest] End UnitTest ALObjectDuplicate  \n\n"


##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALMetaObject )
        self.addTestMethod( self.testALObject )
        self.addTestMethod( self.testALObjectDuplicate )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALObject = ALTestCaseALObject( "TestCase ALObject")
    oalTestCaseALObject.execute()
