#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *


##############################################################################
# ALTrace

class ALTestCaseALTrace( ALTestCase ):

    def testALTrace1(self):
        ALVerbose.unitTest( "UnitTest ALTrace1" )
        ALTrace.trace()
        ALVerbose.unitTest( )


    def testALTrace2(self):
        ALVerbose.unitTest( "UnitTest ALTrace2" )
        try:
            FORCING_AN_ERROR___FORCING_AN_ERROR___FORCING_AN_ERROR___FORCING_AN_ERROR___()
        except:
            ALTrace.trace()
        ALVerbose.unitTest( )


    def testALTrace3(self):
        ALVerbose.unitTest( "UnitTest ALTrace3" )
        ForcingAnError()
        ALVerbose.unitTest( )





##############################################################################

    def process( self ):
        self.addTestMethod( self.testALTrace1 )
        self.addTestMethod( self.testALTrace2 )
        self.addTestMethod( self.testALTrace3 )



##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALTrace = ALTestCaseALTrace( "TestCase ALTrace" )
    oalTestCaseALTrace.execute()
