#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################


from ALImportSystem      import *
from ALImportKernel      import *
from ALImportAction      import *
from ALImportMath        import *



class ALTestCaseALXml( ALTestCase ):
    """
    TestSuite for ALObject Class
    """
    def testALXml( self ):
        ALVerbose.unitTest( "Test ALXml" )

       # oalXml = ALXml()
       # must to try to clone the stupid document to do a copy to our ALXml object type
        oalXml = ALXml.createXml( "./DataForTests/input-test.xml" )

        oalStreamXml = ALStreamXml( "./output-test.xml" )
        oalStreamXml.write( oalXml )
        oalStreamXml.close()

        oalStreamXml2 = ALStreamXml( "./output-test.xml", "r" )
        oalXml2 = oalStreamXml2.read()
        oalStreamXml2.close()

     #   for inode in  oalXml2.getElementsByTagName( "file" ):
     #       oalXmlNode = inode  # impossible to copy the node objects
     #       oUrlOrig = oalXmlNode.getAttribute( "url" )
     #       ALVerbose.screen( ALString( oUrlOrig ) )


        oalXmlString = ALXml.createXmlString( "<buuu> mama </buuu>" )

        oalStreamXml = ALStreamXml( "./output-test-XML-String.xml" )
        oalStreamXml.write( oalXmlString )
        oalStreamXml.close()

        ALVerbose.unitTest()


##############################################################################

    """
    Total compatible with Jython
    """
    def process( self ):
        self.addTestMethod( self.testALXml )


##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    ALCompiler.accelerator()

    oalTestCaseALXml = ALTestCaseALXml( "TestCase ALXml" )
    oalTestCaseALXml.execute()
