#############################################################################
#
#    Project:  PyAALib-JyAALib Asynchronous Action Library Project
#              http://pyaalib.sourceforge.net/
#              http://jyaalib.sourceforge.net/
#
#
#    License:  PyAALib-JyAALib Asynchronous Action Library
#    Copyright (C) 2005, 2006, 2007, 2008, 2009  Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#
#    This program library is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program library is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#
#############################################################################
#
#       File: 
#    Version: 20090428 - Candidate Release 7
#     Author: Romeu Andre' Pieritz (romeu.pieritz@gmail.com)
#
#############################################################################

from ALObject            import ALObject
from ALVerbose           import ALVerbose
from ALString            import ALString
from ALDebug             import ALDebug
from ALTime              import ALTime
from ALDiskExplorer      import ALDiskExplorer
from ALFile              import ALFile
from ALXsdDataBinding    import ALXsdDataBinding


class ALXsdDataBindingEngine( ALXsdDataBinding ):
    """
    Interface for Xsd objects.
    """

    def __init__( self, _oExternalMethod, _oalStrXsdFileName ):
        ALXsdDataBinding.__init__( self, _oalStrXsdFileName )
        self.m_oExternalMethod = _oExternalMethod



    def generateModule( self, _oalPyFileNameOutput, _oalXsdFileNameInput, _nameSpace = "xs:" ):
        oalXsdFileNameTemp = self.setSchemaLocation( _oalXsdFileNameInput, _nameSpace )
        #Path to fix possible bug on Java-Jython: some lazy process or disk writing???
        ALTime.wait(0.1)
        self.m_oExternalMethod( _oalPyFileNameOutput, oalXsdFileNameTemp, "xsd:" )
        ALDiskExplorer.deleteFile( oalXsdFileNameTemp )




    def generateModuleEngine( self, _oalStrModuleFileName, _oalStrXsdFileName ):
        self.generateModule( _oalStrModuleFileName, _oalStrXsdFileName )



    def getObject( self, _oStringNameClass = None ):
        """
        inputs: ( xml file name, module.py file name )
        """
        return self.getObjectParser( None, None, _oStringNameClass )




##############################################################################