#
#    Project: mxPluginExec
#             http://www.edna-site.org
#
#    File: "$Id: EDTestCasePluginExecuteMOSFLMIndexingv10WithForcedSymmetry.py 724 2009-05-20 11:54:26Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal authors:      Marie-Francoise Incardona (incardon@esrf.fr)
#                            Olof Svensson (svensson@esrf.fr) 
#
#    Contributing author:    Karl Levik (karl.levik@diamond.ac.uk)
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Lesser General Public License as published
#    by the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Lesser General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    and the GNU Lesser General Public License  along with this program.  
#    If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib                         import EDCompiler
from EDImportLib                         import EDVerbose
from EDImportLib                         import EDString
from EDImportLib                         import EDDiskExplorer

from EDAssert                            import EDAssert
from EDUtilsTest                         import EDUtilsTest
from EDUtilsPath                         import EDUtilsPath

from EDTestCasePluginExecuteMOSFLMIndexingv10 import EDTestCasePluginExecuteMOSFLMIndexingv10




class EDTestCasePluginExecuteMOSFLMIndexingv10WithForcedSymmetry( EDTestCasePluginExecuteMOSFLMIndexingv10 ):
    """
    """
    
    def __init__( self, _edStringTestName = None):
        """
        """
        EDTestCasePluginExecuteMOSFLMIndexingv10.__init__( self, _edStringTestName )
        
        self.setConfigurationFile( self.getRefConfigFile() )
        self.setDataInputFile( EDDiskExplorer.mergePath( self.m_edStringExecutionTestDataInputHome, "XSDataMOSFLMInputIndexing_withForcedSymmetry.xml" ) )
        
        self.setReferenceDataOutputFile( EDDiskExplorer.mergePath( self.m_edStringExecutionTestDataResultHome, "XSDataMOSFLMOutputIndexing_withForcedSymmetry.xml"))
        self.m_edObtainedOutputDataFile = self.getPluginName() + "_output.xml"



if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()
    
    edTestCasePluginExecuteMOSFLMIndexingv10WithForcedSymmetry = EDTestCasePluginExecuteMOSFLMIndexingv10WithForcedSymmetry( "EDTestCasePluginExecuteMOSFLMIndexingv10WithForcedSymmetry" )
    edTestCasePluginExecuteMOSFLMIndexingv10WithForcedSymmetry.execute()