#
#    Project: EDNA MXv1
#             http://www.edna-site.org
#
#    File: "$Id: EDTestCasePluginExecuteCCP4iv10_withDataSetInput.py 698 2009-05-11 10:43:08Z svensson $"
#
#    Copyright (C) 2008-2009 European Synchrotron Radiation Facility
#                            Grenoble, France
#
#    Principal author:       Marie-Francoise Incardona (incardon@esrf.fr)
#
#    Contributing author:    Olof Svensson (svensson@esrf.fr) 
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#


from EDImportLib                         import EDCompiler
from EDImportLib                         import EDVerbose
from EDImportLib                         import EDString

from EDAssert                            import EDAssert
from EDImportLib                         import EDDiskExplorer
from EDTestCasePluginExecute             import EDTestCasePluginExecute
from EDUtilsTest                         import EDUtilsTest
from EDUtilsPath                         import EDUtilsPath

from EDTestCasePluginExecuteCCP4iv10 import EDTestCasePluginExecuteCCP4iv10

class EDTestCasePluginExecuteCCP4iv10_withDataSetInput( EDTestCasePluginExecuteCCP4iv10 ):
    """
    """
    
    def __init__( self, _edStringTestName = None):
        """
        """
        EDTestCasePluginExecuteCCP4iv10.__init__( self, "EDPluginControlCCP4iv10_withDataSetInput" )
        #EDTestCasePluginExecuteCCP4iv10.__init__( self, "EDPluginControlCCP4iv10_withDataSetInput" )
        self.setConfigurationFile( self.getRefConfigFile() )
        self.setDataInputFile( EDDiskExplorer.mergePath( self.getPluginTestsDataHome(), "XSDataInputFileFromCCP4i_withDataSetInput.xml" ) )
        #self.setReferenceDataOutputFile( EDDiskExplorer.mergePath( self.getPluginTestsDataHome(), "XSDataRaddosev10Output_reference.xml"))
        self.m_edObtainedOutputDataFile = self.getPluginName() + "_output.xml"
        
        
        
    
        
        
##############################################################################


if __name__ == '__main__':

    # JIT compiler accelerator
    EDCompiler.accelerator()
    
    edTestCasePluginExecuteCCP4iv10_withDataSetInput = EDTestCasePluginExecuteCCP4iv10_withDataSetInput( "EDTestCasePluginExecuteCCP4iv10_withDataSetInput" )
    edTestCasePluginExecuteCCP4iv10_withDataSetInput.execute()